<template>
  <div
    class="page-table scrollable only-y"
    id="affix-container"
  >
    <div class="">
      <h1>Jobs</h1>
      <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->

      <el-breadcrumb separator="/">
        <el-breadcrumb-item :to="{ path: '/' }"><i class="mdi mdi-home-outline"></i></el-breadcrumb-item>
        <el-breadcrumb-item :to="{ path: '/jobs' }">Jobs</el-breadcrumb-item>
        <el-breadcrumb-item v-if="!detail.name">None</el-breadcrumb-item>
        <el-breadcrumb-item
          v-if="detail.name !== null"
          :to="{ path: '/jobs/'+ $route.params.id }"
        >{{(detail.name &&  detail.name.length < 50) ? detail.name :  detail.name.substring(0,50)+'...' }}</el-breadcrumb-item>
      </el-breadcrumb>
    </div>
    <br />
    <el-card
      v-if="isContentFound"
      style="text-align: left; margin: 20px 0"
      v-loading="loading"
    >
      <not-found></not-found>
    </el-card>
    <div v-else>
      <el-card
        class="box-card"
        style="text-align: left;"
        v-loading="loading"
      >
        <div
          class="card-inner p-relative"
          v-if="detail"
        >
          <div class="header-tool">
            <el-button
              @click="onEdit"
              class="btn-edit-document btn-edit"
              icon="el-icon-edit"
              circle
              type="primary"
            ></el-button>
          </div>
          <div class="line"></div>
          <el-row :gutter="30">
            <el-col :span="12">
              <div class="img-content-detail">
                <el-carousel
                  v-if="listImage.length "
                  trigger="click"
                >
                  <el-carousel-item
                    v-for="item in listImage"
                    :key="item.url"
                  >
                    <img
                      class="img-full-detail"
                      @click="showAvatar(item.url , $event)"
                      :src="item.url? item.url: $store.state.imgHolder "
                    />
                    <!-- <h3>{{ item }}</h3> -->
                  </el-carousel-item>
                </el-carousel>
                <el-carousel
                  v-if="!listImage.length"
                  trigger="click"
                >
                  <el-carousel-item
                    v-for="item in 1"
                    :key="item.url"
                  >
                    <img
                      class="img-full-detail"
                      @click="showAvatar(item.url , $event)"
                      :src="$store.state.imgHolder"
                    />
                    <!-- <h3>{{ item }}</h3> -->
                  </el-carousel-item>
                </el-carousel>
              </div>

              <h2>{{detail.name}}</h2>
              <div class="giveMeEllipsis">
                <span class="inf-item-title">Description: </span>
                <span class="inf-item-content job-description-detail">{{detail.description}}</span>
              </div>

            </el-col>
            <el-col :span="12">
              <div style="min-height: 252px">
                <div v-if="detail.categoryName">
                  <el-tag
                    type=""
                    class="font-weight-800"
                  >
                    {{detail.categoryName}}
                  </el-tag>
                </div>

                <div
                  class="info-item"
                  title="Employment option"
                >
                  <i class="mdi mdi-clock"></i>
                  <span> {{$helper.replaceUnderscore(detail.employmentType)}}</span>
                  <i class="mdi mdi-minus"></i>
                  <i class="mdi mdi-flash"></i>
                  <span> {{$helper.replaceUnderscore(detail.employmentOption)}}</span>

                </div>

                <div
                  class="info-item"
                  title="Experience"
                >
                  <i class="mdi mdi-star"></i><span> {{parseInt(detail.exp_years) > 0   ? parseInt(detail.exp_years) +' year(s) experience' : 'No experience' }}</span>
                </div>
                <div
                  class="info-item"
                  title="Salary"
                >
                  <i class="mdi mdi-wallet"></i>
                  <span> {{detail.salary}}</span>
                </div>
                <div
                  class="info-item"
                  title="Address"
                >
                  <i class="mdi mdi-map-marker item-icon"></i>
                  <span> {{detail.address}}</span>
                </div>
                <div
                  class="info-item"
                  title="Created at"
                >
                  <i class="mdi mdi-calendar-clock"></i>
                  <span> {{ detail.created_at | moment("DD-MM-YYYY HH:mm:ss") }}</span>
                </div>
              </div>

              <g-maps :location.sync="detail.location">
              </g-maps>
              <br />

              <hr />

              <h2>{{detail.companyName}}</h2>
              <div class="">
                <span class="inf-item-title">Business name:
                  <span class="font-weight-400">{{detail.businessName}}</span>
                </span>
              </div>
              <div class="">
                <span class="inf-item-title">Business type:
                  <span class="font-weight-400">{{detail.businessType}}</span>
                </span>
              </div>
            </el-col>
          </el-row>

        </div>
      </el-card>
      <!-- End job detail here -->

      <!-- Start job post here -->
      <el-card
        class="box-card"
        style="text-align: left; margin: 20px 0"
        v-loading="postLoading"
      >
        <h2>Job Posts</h2>
        <el-table
          :data="postsList"
          style="width: 100%"
          row-class-name="pointer-row"
        >
          <!-- @row-click="showAppHiring" -->
          <el-table-column
            prop="created_at"
            label="Created At"
            min-width="180"
          >
            <template slot-scope="scope">
              <span align="right"> {{scope.row.created_at | moment("DD-MM-YYYY HH:mm:ss") }}</span>
            </template>
          </el-table-column>

          <el-table-column
            min-width="180"
            prop="expired_at"
            label="Expired At"
          >
            <template slot-scope="scope">
              <span align="right"> {{scope.row.expired_at | moment("DD-MM-YYYY HH:mm:ss") }}</span>
            </template>
          </el-table-column>
          <el-table-column
            min-width="180"
            prop="applications_count"
            label="Applications"
          >
          </el-table-column>
          <el-table-column
            min-width="180"
            prop="hirings_count"
            label="Hirings"
          >
          </el-table-column>
          <el-table-column
            align="center"
            prop="status"
            label="Status"
            width="100"
          >
            <template slot-scope="scope">
              <div style="text-align: center">
                <span
                  v-if="scope.row.status == 'inactive' || scope.row.status == 'active'"
                  class="lbl lbl-success giveMeEllipsis"
                >{{$helper.replaceUnderscore(scope.row.status)}}</span>
                <span
                  v-else
                  class="lbl lbl-primary giveMeEllipsis"
                >{{$helper.replaceUnderscore(scope.row.status)}}</span>
              </div>
            </template>
          </el-table-column>
          <el-table-column width="40">
            <template slot-scope="scope">
              <el-dropdown
                type="primary"
                trigger="click"
                @command="command => showDialog(command,scope.row.id)"
              >
                <span class="el-dropdown-link">
                  <i
                    style="font-size: 18px; line-height: 16px"
                    class="mdi mdi-dots-vertical"
                  ></i>
                </span>
                <el-dropdown-menu
                  slot="dropdown"
                  style="overflow: hidden;"
                >
                  <el-dropdown-item
                    command="application"
                    :job_post_id="scope.row.id"
                  >Show Applications</el-dropdown-item>
                  <el-dropdown-item command="hiring">Show Hirings</el-dropdown-item>
                </el-dropdown-menu>
              </el-dropdown>
            </template>
          </el-table-column>
        </el-table>
      </el-card>
      <!-- End job post here -->
      <post-application-hiring
        :showApplicationDialog.sync="showApplicationDialog"
        :applications="applications"
        :hiring="hiring"
        :job_post_id.sync="job_post_id"
      ></post-application-hiring>
      <post-hiring
        :showHiringDialog.sync="showHiringDialog"
        :applications="applications"
        :hiring="hiring"
        :job_post_id.sync="job_post_id"
      ></post-hiring>

      <view-image
        :dialogvisible.sync="dialogvisible"
        :imageUrl.sync="imageUrl"
      >
      </view-image>
    </div>
  </div>
</template>

<script>
import ViewImage from "~/components/dialogs/ViewImage";
import { job as jobApi, post as postAPI } from '~/services/apis/index'
import GMaps from '~/components/dialogs/LocationMap.vue'
import NotFound from '../ContentNotFound'
import helper from '~/services/helper'
import PostApplicationHiring from '~/components/dialogs/PostApplicationHiring.vue'
import PostHiring from '~/components/dialogs/PostHiring.vue'
export default {
  name: 'JobDetail',
  components: {
    PostApplicationHiring,
    PostHiring,
    GMaps,
    NotFound,
    ViewImage,
  },
  data () {
    return {
      detail: {
        name: '',
        timePost: '',
        created_at: "",
        description: '',
        categoryName: "No category",
        employmentType: "",
        employmentOption: "",
        exp_years: "",
        salary: "",
        location: {},
        address: "",
        latitude: "",
        longitude: "",
        cover: "",
        companyName: "",
        businessName: "",
        businessType: "",
        companyDescription: "",
      },
      postsList: [],
      listImage: [],
      loading: true,
      postLoading: true,
      currentPage: 1,
      total: 0,
      pageSize: this.$store.state.itemPerPage,
      isContentFound: false,
      dialogvisible: false,
      imageUrl: null,
      showApplicationDialog: false,
      showHiringDialog: false,
      applications: [],
      hiring: [],
      job_post_id: '',

    }
  },
  methods: {
    /* Get all images job*/
    getImagesJob () {
      this.imageLoading = true;
      jobApi.getImagesJob(this.$route.params.id)
        .then(res => {
          res.data.data.sort((a, b) => parseInt(a.position) - parseInt(b.position));
          if (res.data.success) {
            res.data.data.length >= 6 ? res.data.data.length = 6 : res.data.data
            this.listImage = [...res.data.data]
          }
          this.imageLoading = false
        })
        .catch(err => {
          console.log(err);
          this.imageLoading = false
        })
    },
    handleClick () {
      /*eslint-disable*/
      console.log('hello');
    },
    getSeekerDetail () {
      if (!this.$route || !this.$route.params.id) return;
      jobApi.getJob(this.$route.params.id)
        .then((res) => {
          this.initDetail(res.data.data);
          this.isContentFound = false;
          this.loading = false;
        })
        .catch((err) => {
          this.isContentFound = true;
          this.loading = false;
        })
    },
    getListPost () {
      this.postLoading = true;
      postAPI.getPosts(this.currentPage, 10, 'id', 'desc', this.$route.params.id)
        .then((res) => {
          /*eslint-disable*/
          this.postsList = res.data.data;
          this.postLoading = false;
        });
    },
    initDetail (data) {
      if (!data) return;
      this.detail.created_at = data.created_at;
      this.detail.name = data.position;
      this.detail.description = data.description;
      this.detail.timePost = data.created_at;
      this.detail.employmentType = data.employment_type;
      this.detail.employmentOption = data.employment_option;
      this.detail.exp_years = data.exp_require;
      this.detail.location = data.location;

      this.detail.salary = this.formatSalary(data.salary_from, data.salary_to);

      if (data.category && data.category.name)
        this.detail.categoryName = data.category.name;

      if (data.logo && data.logo.url)
        this.detail.cover = data.logo.url;

      if (data.workplace) {
        if (data.workplace.company) {
          this.detail.companyName = data.workplace.company.name;
          this.detail.businessName = data.workplace.company.business_name;
          this.detail.businessType = data.workplace.company.business_type;
          this.detail.companyDescription = data.workplace.company.business_description;
        }

        if (data.workplace.address) {
          this.detail.address = data.workplace.address.street;
          this.detail.latitude = data.workplace.address.latitude;
          this.detail.longitude = data.workplace.address.longitude;
          this.detail.phone_number = data.workplace.address.phone_number;
          this.detail.phone_number_verified_at = data.workplace.address.phone_number_verified_at;

          this.detail.location = {
            lat: Number(this.detail.latitude),
            lng: Number(this.detail.longitude)
          }
        }
      }
    },
    formatSalary (from, to) {
      if (!from && !to) {
        return ""
      }

      return "From " + helper.formatNumber(from) + " To " + helper.formatNumber(to);
    },
    onChangePage (page) {
      this.currentPage = this.$helper.formatPage(page)
      //this.$router.push({query: {page: page}})
      this.getListPost();
    },
    showAvatar (url, event) {
      if (event) {
        event.preventDefault();
        event.stopPropagation();
      }

      if (!url) return;
      this.imageUrl = url;
      this.dialogvisible = true;
    },
    onEdit () {
      this.$router.push({ name: 'jobs_edit' });
    },
    showDialog (name, id) {
      this.job_post_id = id;
      console.log('name :', name);
      console.log('scope :', id);
      name && name === 'application' ? this.showApplicationDialog = true : name === 'hiring' ? this.showHiringDialog = true : this.showApplicationDialog = this.showApplicationDialog = false
    },
    showAppHiring (row) {
      console.log('row :', row);
      console.log('command :', command);
      this.job_post_id = row;
      this.showApplicationDialog = true;
    },

  },

  mounted () {
    this.getImagesJob();
    this.getSeekerDetail();
    this.getListPost();

  }
}
</script>

<style scope>
.job-description-detail {
  white-space: pre-line;
}
.inf-item-title {
  font-weight: bold;
}

.info-item {
  line-height: 35px;
}

.info-item i {
  font-weight: bold;
}
.info-item span {
  margin-left: 10px;
}
.img-full-detail {
  height: 100%;
}
.img-content-detail {
  width: 100%;
  height: 387px !important;
  position: relative;
  /*background-color: #63696c;*/
  background: transparent;
  padding: 5px;
  border: 1px solid rgba(74, 89, 106, 0.1);
}

.time-count {
  font-style: italic;
  font-size: 14px;
  color: #fff;
  margin: 10px;
  padding: 5px;
  margin-right: 0;
  display: inline-block;
  position: absolute;
  right: 0;
  background-color: #0000006b;
}

.giveMeEllipsis {
  overflow: hidden;
  text-overflow: ellipsis;
  display: -webkit-box;
  -webkit-box-orient: vertical;
  -webkit-line-clamp: 3; /* number of lines to show */
  /*line-height: 3;        !* fallback *!*/
  /*max-height: 10px;       !* fallback *!*/
}
.el-carousel {
  height: 100%;
}
.el-carousel__container {
  height: 100%;
}
.g-map {
  position: absolute;
  bottom: 0px;
}
.el-carousel__arrow {
  background-color: rgba(74, 89, 106, 2.1);
}
.el-carousel__arrow:hover {
  background-color: rgba(74, 89, 106, 2.1);
}
</style>
